# from decimal import Context
# from typing import get_origin
from django.db.models.expressions import F
from django.http import response
from django.views import View, generic
from django.shortcuts import render
from django.contrib import messages
from django.contrib.auth.views import LoginView, LogoutView
from django.db import connection as conn, models
from django.core import serializers
from django.contrib.auth.models import User,Group
from django.contrib.auth.hashers import make_password
from rest_framework import status
from rest_framework.decorators import api_view, renderer_classes
from rest_framework.response import Response



# Create your views here.
class CustomLoginView(LoginView):
    template_name = 'user/login.html'
    redirect_authenticated_user = True

class HomeView(View):
    template_name = 'layout/layout.html'

    def get(self, request):
        return render(request, self.template_name)

class CustomLogoutView(LogoutView):
    template_name = 'user/login.html'
    next_page = 'login'

class Usermanagement(generic.TemplateView):
    template_name = "layout/user_layout.html"
    
    def get(self, request):
        with conn.cursor() as userlist_:
            userlist_.execute("SELECT * from auth_user ORDER BY username ASC")
            allUser = userlist_.fetchall()

        
        user_res = []
        for rows in allUser:
            datas = {
                "id": rows[0],
                "username": rows[4],
                "name": rows[5] +" "+ rows[6],
                "email": rows[7],
                "isactive": rows[9],
                "last": rows[2] 
            }
            user_res.append(datas)

        with conn.cursor() as grouplist_:
            grouplist_.execute("SELECT * FROM auth_group ORDER BY name ASC")
            allGroup = grouplist_.fetchall()

        group_res = []
        for rows in allGroup:
            datas = {
                "id" : rows[0],
                "name" : rows[1],
            }
            group_res.append(datas)
        
        context = {
            'title' : 'user management',
            'data'  : user_res,
            'dataGroup' : group_res
        } 

        print(context)
        return render(request, self.template_name, context)

@api_view(('POST',))
def addUser(request):
    
    if request.method == 'POST':
        
        usernames   = request.POST.get('username')
        first_name  = request.POST.get('first_name')
        last_name   = request.POST.get('last_name')
        group       = request.POST.get('group')
        email       = request.POST.get('email')
        password    = request.POST.get('username')
        iduser      = request.POST.get('id')
        arrGroup    = group.split("~")
        
        user = User()
        
        # user.save()
        try:
            if iduser:
                with conn.cursor() as cursor:
                    cursor.execute("UPDATE auth_user SET first_name = '"+first_name+"', last_name = '"+last_name+"', email = '"+email+"' WHERE id="+iduser)
                
                with conn.cursor() as curGroup:
                    curGroup.execute("DELETE FROM auth_user_groups WHERE user_id="+iduser)

                users = User.objects.get(username=usernames)
                for i in arrGroup:
                    insertgroups = Group.objects.get(name=i)
                    insertgroups.user_set.add(users)

                data = {
                    "code" : 0,
                    "data" : "User telah diperbaharui.",
                    "info" : "success"
                }
            else:
                user = User.objects.get(username=usernames)
                data = {
                    "code" : 4,
                    "data" : "username telah tersedia, silahkan coba lagi.",
                    "info" : "failed"
                }

        except User.DoesNotExist:
            user.username    = usernames
            user.first_name  = first_name
            user.last_name   = last_name
            user.email       = email
            user.password    = make_password(password)
            user.save()
            
            # add user to group
            userinsert   = User.objects.get(username=usernames)
            for i in arrGroup:
                insertgroups = Group.objects.get(name=i)
                insertgroups.user_set.add(userinsert)

            data = {
                "code" : 0,
                "info" : "success",
                "data" : "user "+usernames+" berhasil ditambahkan"
            }
    
    # data = {'sukses':'sukses'}
    return Response(data)

@api_view(('POST',))
def listGroup(request):
    if request.method == "POST":
        groupList = Group.objects.all().order_by('name')

        group = []
        for g in groupList:
            group.append(g.name)
            
        if len(group) > 0:
            data = {
                "info" : "success",
                "code" : 0,
                "data" : group
            }
        else:
            data = {
                "info" : "group tidak tersedia",
                "code" : 4,
                "data" : group
            }

    return Response(data)

@api_view(('POST',))
def deactivateUser(request):
    
    user = User()
    if request.method == "POST":
        ids     = request.POST.get('id')
        status  = request.POST.get('stat')

        isActive = loadUserStatus(ids)
        # print(type(status)+status)
        # print(type(True))
        print(status == 'True')
        if status == 'True':
            sql = "f"
        else:
            sql = "t"

        with conn.cursor() as cursor:
            affected_row = cursor.execute("UPDATE auth_user SET is_active = '"+sql+"' WHERE id = "+ids)
        
        print ("UPDATE auth_user SET is_active = '"+sql+"' WHERE id = "+ids)
        print (affected_row)
        if affected_row:
            data = {
                "info" : "success",
                "code" : 0,
                "data" : "User berhasil dinonaktifkan"
            }
        else:
            data = {
                "info" : "success",
                "code" : 0,
                "data" : "User berhasil dinonaktifkan"
            }

    return Response(data)


def loadUserStatus(id):

    with conn.cursor() as cursor:
        cursor.execute("SELECT is_active from auth_user WHERE id="+id+"")
        resData = cursor.fetchall()

    for i in resData:
        isActive = i[0]
    
    return isActive

@api_view(('POST',))
def loadUserbyId(request):
    if request.method == "POST":
        id = request.POST.get('id')

        print(id)
        with conn.cursor() as cursor:
            cursor.execute("SELECT * FROM auth_user WHERE id ="+id)
            result = cursor.fetchall()

        group_res = loadGroupById(id)
        user_res  = []
        for rows in result:
            datas = {
                "id"       : rows[0],
                "username" : rows[4],
                "firstname": rows[5],
                "lastname" : rows[6],
                "email"    : rows[7],
                "isactive" : rows[9],
                "last"     : rows[2],
                "group"    : group_res
            }
            user_res.append(datas)

        data = {
            "info" : "success",
            "code" : 0,
            "data" : datas,
        }
        

    return Response(data)

def loadGroupById(iduser):

    with conn.cursor() as cursor:
        cursor.execute("select ag.name from auth_group ag, auth_user_groups aug WHERE aug.user_id = "+iduser+" AND ag.id = aug.group_id")
        result = cursor.fetchall()

    print(result)
    resGroup = []
    for i in result:
        resGroup.append(i[0])
    
    print(resGroup)
    return resGroup

@api_view(('POST',))
def addGroup(request):
    
    if request.method == "POST":
        name    = request.POST.get('name')
        idgroup = request.POST.get('id')
        
        try:
            if idgroup:
                with conn.cursor() as cursor:
                    cursor.execute("UPDATE auth_group SET name = '"+name+"' WHERE id="+idgroup)
                    result = cursor.rowcount

                print(result)
                data = {
                    "code" : 0,
                    "data" : "Group telah diperbaharui.",
                    "info" : "success"
                }
            else:
                group = Group.objects.get(name=name)
                data  = {
                    "code" : 4,
                    "data" : "Group telah tersedia.",
                    "info" : "failed"
                }

        except Group.DoesNotExist:
           
            Group.objects.create(name=name)
            if Group.objects.get(name=name):
                data = {
                    "code" : 0,
                    "info" : "success",
                    "data" : "Group berhasil ditambahkan"
                }
            else:
                data = {
                    "code" : 4,
                    "info" : "failed",
                    "data" : "Group gagal ditambahkan"
                }

    return Response(data)

@api_view(('POST',))
def deleteGroup(request):

    if request.method == "POST":
        id = request.POST.get('id')

        with conn.cursor() as cursor:
            cursor.execute("DELETE FROM auth_group WHERE id="+id)
            result = cursor.rowcount

        if result > 0:
            data = {
                "code" : 0,
                "info" : "success",
                "data" : "data berhasil dihapus"
            }
        else:
            data = {
                "code" : 4,
                "info" : "success",
                "data" : "data berhasil dihapus"
            }
        

    return Response(data)